package school_project;

import java.io.*;
import java.lang.reflect.Array;
import java.util.Arrays;

public class MapParser {
    public static Map ParseMapFile(File file) throws IllegalArgumentException, IllegalAccessException, IOException {
        System.out.println(file.getAbsolutePath());
        FileInputStream fileStream = new FileInputStream(file);
        if(!file.isFile()) throw new IllegalArgumentException("The argument should be a file");
        if(!file.canRead()) throw new IllegalAccessException("This file can't be read");

        byte[] bytes = fileStream.readAllBytes();
        int start_position = 0, end_position = 0;
        for (int i = 0; i < bytes.length; i++) {
            if(bytes[i] == 83 && bytes[i+1] == 77 && bytes[i+2] == 83){ // SMS
                start_position = i+3;
                break;
            }
        }

        for (int i = start_position; i < bytes.length; i++) {
            if(bytes[i] == 83 && bytes[i+1] == 77 && bytes[i+2] == 69){ // SME
                end_position = i;
                break;
            }
        }

        byte[] level_data = Arrays.copyOfRange(bytes, start_position, end_position);
        int width_map = level_data[0], height_map = level_data[1];
        byte[] map_data = Arrays.copyOfRange(level_data, 2, 2 + width_map * height_map / 8 + (height_map * width_map % 8 != 0 ? 1 : 0));
        byte piece_count = level_data[3 + width_map * height_map / 8 + (height_map * width_map % 8 != 0 ? 1 : 0)];
        byte[] pieces_datas = Arrays.copyOfRange(level_data, 4 + width_map * height_map / 8 + (height_map * width_map % 8 != 0 ? 1 : 0), level_data.length-1);
        for (int piece_index = 0; piece_index < piece_count; piece_index++) {



        }
        fileStream.close();
        return new Map(); //TODO: Send the parsed map
    }

//    public static void SaveMapFile(File file){
//    }


    private static boolean[][] BuildMatrixFromBytes(int map_width, int map_height, byte[] map_data){
        boolean[][] ret = new boolean[map_height][map_width];
        //TODO tonitch: cursor 2

    }
    public static void main(String[] args) throws IOException, IllegalAccessException {
        ParseMapFile(new File("test.smap"));
    }

}
